<template>
  <creation-step
    form-title="Réservez une navette"
    :previous-step="{ name: 'campus-campus_id-select-type', params: { campus_id: campus.id }}"
    @submit="submit"
  >
    <template
      v-if="!user.gprd"
      #alert
    >
      <gprd-warning />
    </template>
    <template #form>
      <fieldset class="fields-box">
        <ec-field
          v-if="!user.phone || !user.phone.confirmed"
          class="phone"
        >
          Si vous souhaitez être notifié sur votre téléphone, vous devez
          <nuxt-link :to="{name: 'my-account-edit-account'}">
            renseigner et confirmer votre numéro de téléphone
          </nuxt-link>
        </ec-field>

        <ec-field
          label="Date et heure de départ"
          field-id="start"
          class="date"
        >
          <client-only>
            <date-time
              id="start"
              v-model="date"
              :disabled-date="dayReservationScope"
              :disabled-time="hourReservationScope"
              lang="fr"
              confirm
              append-to-body
              :show-second="false"
              type="datetime"
              input-class="input"
              placeholder="Sélectionner une date"
            />
          </client-only>
        </ec-field>

        <ec-field
          label="Trajets possibles"
          field-id="shuttle-factory"
          class="shuttle-factory"
        >
          <vue-multiselect
            :value="shuttleFactory"
            :placeholder="date && availableFactories.length === 0 ? 'Pas de navettes prévues' :
              'Sélectionner une navette'"
            :options="availableFactories"
            track-by="id"
            label="label"
            :disabled="!date || date && availableFactories.length === 0"
            @input="selectShuttleFactory"
          />
        </ec-field>

        <template v-if="date && availableFactories.length > 0">
          <template v-if="shuttleFactory">
            <ec-field
              label="Arrêt de départ"
              field-id="departure"
              class="departure"
            >
              <vue-multiselect
                v-model="departure.stop"
                :options="stops"
                track-by="id"
                label="label"
              >
                <template #placeholder>
                  <fa-icon :icon="['fas', 'map-marker-alt']" />
                  <span>Sélectionner votre arrêt</span>
                </template>
              </vue-multiselect>
            </ec-field>

            <ec-field
              v-if="shuttleFactory"
              label="Arrêt d'arrivée"
              field-id="arrival"
              class="arrival"
            >
              <vue-multiselect
                v-model="arrival.stop"
                :options="endStops"
                track-by="id"
                label="label"
              >
                <template #placeholder>
                  <fa-icon :icon="['fas', 'map-marker-alt']" />
                  <span>Sélectionner votre arrêt</span>
                </template>
              </vue-multiselect>
            </ec-field>
            <template v-if="departure.stop && arrival.stop">
              <ec-field
                label="Heure de passage estimée"
                field-id="start"
              >
                <vue-multiselect
                  :value="departure.date"
                  :options="possibleStarts"
                  track-by="id"
                  label="label"
                  :disabled="!departure.stop || !arrival.stop"
                  placeholder="Veuillez sélectionner un horaire"
                  @input="updateSelectedShuttle"
                />
              </ec-field>

              <ec-field
                label="Heure d'arrivée estimée"
                field-id="end"
                class="end"
              >
                <input
                  class="input"
                  type="text"
                  :value="ISODateToLocaleString(arrival.date, HOUR_AND_MINUTES_TWO_DIGITS)"
                  disabled
                >
              </ec-field>
            </template>
          </template>
        </template>
      </fieldset>
      <form-button :disabled="!date || !shuttleFactory || shuttles.length === 0" />
    </template>
    <template #footer>
      <shuttle-factories-map
        class="map"
        :campus="campus"
        :shuttle-factories="shuttleFactories"
        @click="selectShuttleFactory"
      />
    </template>
  </creation-step>
</template>

<script>
import { DateTime } from 'luxon';
import { CREATED } from '@fabnumdef/e-chauffeur_lib-vue/api/status/states';
import gprdWarning from '~/components/creation-step/gprd-warning.vue';
import creationStep from '~/components/creation-step/generic.vue';
import formButton from '~/components/creation-step/form-button.vue';
import errorsManagement from '~/helpers/mixins/errors-management';
import datePickerMixin from '~/helpers/mixins/date-picker';
import shuttleFactoriesMap from '~/components/maps/shuttle-factories.vue';
import { generateTitles } from '~/store/context';
import init from '~/components/creation-step/mixins/init-component';

const TITLE = 'Réservez votre navette dès maintenant !';
const SUBTITLE = 'Sélectionnez d\'abord la date et le trajet que vous souhaitez emprunter.';
const SHUTTLE_FACTORY_MASK = 'id,label,stops';
const SHUTTLE_MASK = 'id,label,status,start,end,campus,shuttleFactory,passengers,comments,recurrence';

const formatStops = (stop, index) => ({ ...stop, label: `${index + 1} : ${stop.label}` });

export default {
  components: {
    shuttleFactoriesMap,
    creationStep,
    gprdWarning,
    formButton,
  },
  mixins: [
    init(generateTitles(TITLE, SUBTITLE)),
    errorsManagement(),
    datePickerMixin(),
  ],
  props: {
    campus: {
      type: Object,
      default: () => ({}),
    },
  },
  async asyncData({ $api, params }) {
    const { campus_id: campusId } = params;
    const { data: user } = await $api.query('jwt').setMask('gprd,phone(confirmed)').user();
    const { data: shuttleFactories } = await $api.query('shuttleFactories')
      .setMask(SHUTTLE_FACTORY_MASK).setCampus(campusId).list();

    const { data: campus } = await $api.query('campuses').setMask('defaultReservationScope').get(campusId);
    const start = DateTime.local().toJSDate();
    const end = DateTime.local().plus({ seconds: campus.defaultReservationScope }).toJSDate();
    const { data: shuttles } = await $api.query('shuttles')
      .setMask(SHUTTLE_MASK)
      .setCampus(campusId)
      .list(start, end)
      .setFilter('status', CREATED);

    return {
      user,
      shuttleFactories,
      shuttles,
    };
  },
  data() {
    return {
      date: null,
      shuttleFactory: null,
      shuttles: [],
      departure: {
        stop: null,
        date: null,
      },
      arrival: {
        stop: null,
        date: null,
      },
    };
  },
  computed: {
    HOUR_AND_MINUTES_TWO_DIGITS() {
      return { hour: '2-digit', minute: '2-digit', hour12: false };
    },
    stops() {
      return this.shuttleFactory.stops.map(formatStops).slice(0, this.shuttleFactory.stops.length - 1);
    },
    endStops() {
      let endStops = this.shuttleFactory.stops.map(formatStops).slice(1, this.shuttleFactory.stops.length);

      if (this.departure.stop) {
        const [departureIndex] = this.departure.stop.label.split(' ');
        if (+departureIndex === 1) {
          return endStops;
        }

        let isDeparture = false;
        endStops = endStops.filter((stop) => {
          if (!isDeparture && stop.id === this.departure.stop.id) {
            isDeparture = true;
            return false;
          }
          return isDeparture;
        });
      }
      return endStops;
    },
    todayShuttles() {
      return this.shuttles.filter(({ start, status }) => status === CREATED
          && start <= DateTime.fromJSDate(this.date).endOf('day').toISO());
    },
    possibleStarts() {
      if (this.departure.stop) {
        if (this.todayShuttles.length > 0) {
          return this.todayShuttles.map(({ id, shuttleFactory }) => {
            const concernedStop = shuttleFactory.stops.find((stop) => stop.id === this.departure.stop.id);
            return {
              id,
              label: `${this.ISODateToLocaleString(concernedStop.time, this.HOUR_AND_MINUTES_TWO_DIGITS)}`,
              ISO: concernedStop.time,
            };
          });
        }
      }
      return [];
    },
    availableFactories() {
      if (this.date) {
        return this.shuttleFactories
          .filter(({ id }) => this.todayShuttles
            .find((shuttle) => shuttle.shuttleFactory.id === id));
      }
      return [];
    },
  },
  watch: {
    'arrival.stop': {
      handler() {
        if (this.selectedShuttle) {
          const concernedStop = this.selectedShuttle.shuttleFactory.stops.find((stop) => stop.id
            === this.arrival.stop.id);
          this.arrival.date = concernedStop.time;
        }
      },
    },
  },
  methods: {
    ISODateToLocaleString(date, format = {}) {
      if (date) {
        return DateTime.fromISO(date).toLocaleString(format);
      }
      return null;
    },
    updateSelectedShuttle(stop) {
      this.selectedShuttle = this.shuttles.find((shuttle) => shuttle.id === stop.id);
      this.departure.date = stop;
      if (this.arrival.stop) {
        const endStop = this.selectedShuttle.shuttleFactory.stops
          .find((s, index) => index > 0 && s.id === this.arrival.stop.id);
        this.arrival.date = endStop.time;
      }
    },
    async selectShuttleFactory(data) {
      this.shuttleFactory = data;
      const end = DateTime.fromJSDate(this.date).plus({ days: 30 }).toISO();
      this.handleCommonErrorsBehavior(async () => {
        const { data: shuttles } = await this.$api.query('shuttles')
          .setMask(SHUTTLE_MASK)
          .setCampus(this.campus.id)
          .list(this.date, end)
          .setFilter('shuttleFactory._id', this.shuttleFactory.id);
        this.shuttles = shuttles;
      });
    },
    submit() {
      this.$router.push({
        name: 'campus-campus_id-shuttles-confirm',
        params: { campus_id: this.campus.id },
        query: {
          shuttle: this.selectedShuttle.id,
          departure: this.departure.stop.id,
          arrival: this.arrival.stop.id,
        },
      });
    },
  },
};
</script>
<style lang="scss" scoped>
  @import "~assets/css/head";
  .form {
    position: relative;
    .mx-datepicker {
      width: 100%;
      margin-bottom: 1em;
    }
    fieldset {
      display: grid;
      grid-template-columns: repeat(2, 1fr);
      .phone {
        grid-column: 1/3;
        a {
          text-decoration: underline;
          font-weight: 700;
        }
        /deep/ .control {
          text-align: center;
        }
      }
      .date {
        grid-column: 1;
        grid-template-columns: repeat(2, 1fr);
        .mx-datepicker {
          width: 100%;
        }
      }
      .shuttle-factory {
        grid-column: 2;
      }
      .departure {
        grid-column: 1;
      }
      .arrival {
        grid-column: 2;
      }
      .start {
        grid-column: 1;
      }
      .end {
        grid-column: 2;
      }
      .alert {
        font-weight: 700;
        text-align: center;
      }
    }

    @media screen and (max-width: 600px) {
      fieldset {
        display: flex;
        flex-direction: column;
        align-items: center;
        .field {
          width: 100%;
        }
      }
    }
  }
</style>
